
comment 
dans WM_CREATE
		invoke Creer_Listview,hwnd,addr Listview
		invoke CreerRemplirLigneListview,0,addr Listview_ligne
dans WM_NOTIFY
		.if edx == Listview.Handle
			invoke Notify_Listview,uMsg,wParam,lParam
		.endif		  		



.const
;declarations
;------ inclure perso32 -----------

Listview_DATA	STRUCT
	TableEntete		dd ?
	TableLargeEntete	dd ?
	;-------------------------- DIM_CREATEWIN -----------------------
	posX			dd ?		;conserver dans l'ordre
	posY			dd ?
	largeur		dd ?
	hauteur		dd ?
	;------------------------------------------------------------------
	Handle		dd ?
	NbCol			dd ?		;ne pas remplir	
Listview_DATA	ENDS

;positionnement et dimensions du contrle
DIM_CREATEWIN STRUCT
	posX		dd ?
	posY		dd ?
	largeur  	dd ?	
	hauteur	dd ?
DIM_CREATEWIN ENDS

Creer_Listview 			PROTO  :DWORD ,:DWORD
TransformePourCent 		PROTO  :DWORD ,:DWORD
Notify_Listview			PROTO  :DWORD ,:DWORD ,:DWORD
CreerRemplirLigneListview	PROTO NumeroLigne:DWORD,pDataLigne:DWORD

;dans librairie
;PourCent et TransformePourCent

.data
hInstance dd 0	

;-------------------------------- IMPORTANT ----------------------------------------------
;dans le code,au dmarrage "invoke     InitCommonControlsEx,addr InitControl"
InitControl			INITCOMMONCONTROLSEX <sizeof INITCOMMONCONTROLSEX,ICC_LISTVIEW_CLASSES or ICC_BAR_CLASSES>
;tout ce que vous avez a faire est de rajouter ou suprimer des titres en les modifiant
;le tableau Entete_Col_Listview_large donne la largeur des colonnes en % de la longueur de la Listview
;il doit y avoir autant de longueur que de titres en respectant les caractres de terminaisons
;des tableaux byte 0 pour titres et dd 0 pour longuueur
;si vous n'tes pas sur de vous,lancer le tel que et modifier le apres
;vous obtiendrez 3 colonnes nommes titre1 titre2 titre3
;quand tout est fini "invoke Creer_Modele_Listview,hwnd,addr Modele_Listview" dans WM_CREATE
;---------------------- NE MODIFIER RIEN D'AUTRE -----------------------------------------
;-------------------------------------------------------------------------------------------


Col_Listview_nom 			db "titre1",0
		    			db "titre2",0
		    			db "titre3",0
					db "bidule",0
					db 0				;zero,fin des titres
		
Col_Listview_large		dd  30			;en % total=100
					dd  30			;100% / 3
					dd  30			;le dernier rcupre le reste
					dd  10 
					dd  0				;fin des largeurs

;--------------- dimensionner le control lui mme 0,0,100,100,,> ----------------------------
;le seul cas ou la somme des pourcentages ne doit pas faire 100
;ce sont les dimensions de la Listview pass a CreateWindowEx ,,,PosX,PosY,largeur,hauteur,,
;pour centrer la fenetre 2 * posX + largeur = 100
;				 2 * posY + hauteur = 100

Listview Listview_DATA	<Col_Listview_nom,Col_Listview_large,0,0,100,100,,>
Listview_ligne db "un,deux,trois,quatre",0
ClassListview DB "SysListView32",0
.code

;dans WM_CREATE


;################################################################
Creer_Listview PROC uses esi edi ebx hwnd:DWORD,pListview:DWORD
			Local   Nbcol:DWORD
			Local   CPT:DWORD,largemere,hautmere,largelsv
			Local   rect:RECT
			;local  lvitem:LVITEM
			local NBLVligne:DWORD
			local lvc:LV_COLUMN
			;local lvi:LV_ITEM
			Local  retour:DWORD
			ZEROLOCALES retour
			
		mov ebx,pListview
		;vrifier les paramtres
		.if 	hwnd == 0 || pListview == 0
			jmp FindeCreer_Listview
		.endif
		;compter le nombre de colonnes et de largeur
		mov esi,[Listview_DATA.TableEntete][ebx]
		@@:
		invoke lnstr,esi
		inc Nbcol
		add esi,eax
		inc esi
		mov al,BYTE ptr [esi]
		.if al != 0
			jmp @B
		.endif
		;------------------------------------------
		mov esi,[Listview_DATA.TableLargeEntete][ebx]
		@@:
		.if dword ptr [esi] != 0
			inc CPT
			add esi,4
			jmp @B		
		.endif
		mov eax,CPT
		.if eax != Nbcol
			jmp FindeCreer_Listview			
		.endif
		PuPo [Listview_DATA.NbCol][ebx],Nbcol
		;si hwnd null,le controle doit avoir la proprit child
		;si non child ,corrig les paramtres posx et pos y
		;donn en fonction de l'cran et non de la feuille mre
		invoke TransformePourCent,hwnd,addr Listview.posX
		;------------------  crer Listview -----------------------------------
		;attention a l'vnement resize,si il est utilis
		;il vous faudra tenir compte de la Listview
		invoke CreateWindowEx,NULL,addr ClassListview,NULL,\
			WS_CHILD or WS_VISIBLE or WS_VSCROLL or WS_HSCROLL or LVS_REPORT,\
			Listview.posX,Listview.posY,Listview.largeur,Listview.hauteur,\
			hwnd,NULL,hInstance,NULL
			;CW_USEDEFAULT
		mov retour,eax
		mov [Listview_DATA.Handle][ebx],eax
		.if eax == 0
			jmp FindeCreer_Listview
		.endif		
		mov     eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or\
			LVS_EX_GRIDLINES
		INVOKE     SendMessage, retour, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax		
		;positionner pointeurs
		mov esi,[Listview_DATA.TableEntete][ebx]
		mov edi,[Listview_DATA.TableLargeEntete][ebx]		
		mov eax,[Listview_DATA.largeur][ebx]
		mov largelsv,eax
		;dfinir les colonnes
			xor eax,eax
			mov NBLVligne,eax
			mov lvc.imask,LVCF_TEXT+LVCF_WIDTH			;utile	
			mov CPT,0							
		.while (Nbcol)
			inc CPT
			mov lvc.pszText,esi
			mov edx,[edi]
			invoke PourCent,largelsv,edx			
			mov lvc.lx,eax
			invoke SendMessage,retour, LVM_INSERTCOLUMN,CPT,addr lvc	
			dec Nbcol
			.if Nbcol != 0
				invoke lnstr,esi
				add esi,eax
				inc esi
				add edi,4			
			.endif
		.endw
 FindeCreer_Listview:
         mov eax,retour
         ret
Creer_Listview endp


comment 
dans la feuille mere
	.elseif uMsg == WM_NOTIFY
		mov     ebx, lParam          ; Get pointer to NMHDR
		mov     eax, (NMHDR ptr [ebx]).code		;ex:TTN_NEEDTEXT ou EN_SELCHANGE
		mov     edx,(NMHDR ptr [ebx]).hwndFrom
			 ; valeur de retour ignore sauf specification contraire
		.if edx == Listview.Handle
			invoke Notify_Listview,uMsg,wParam,lParam
		.endif




;################################################################
Notify_Listview PROC uses ebx uMsg:DWORD, wParam:DWORD, lParam:DWORD 
			Local  retour:DWORD	;valeur ignor sauf spcification contraire
         mov retour,1
		mov     ebx, lParam          ; Get pointer to NMHDR
		mov     eax, (NMHDR ptr [ebx]).code		;ex:TTN_NEEDTEXT ou EN_SELCHANGE
		mov     edx,(NMHDR ptr [ebx]).hwndFrom
	;uMsg = WM_NOTIFY et edx = Handle de Listview
		
				
		.if eax == LVN_BEGINDRAG
		;Drag-and-drop operation with left mouse button is being initiated	
		.elseif eax == LVN_BEGINLABELEDIT
		;Item in-place label editing has started	
		.elseif eax == LVN_BEGINRDRAG
		;Drag-and-drop operation with right mouse button is being initiated	
		.elseif eax == LVN_COLUMNCLICK
		;A column was clicked	
			invoke MessageBox,NULL,SADR("A column was clicked"),SADR("Titre"),MB_OK
		.elseif eax == LVN_DELETEALLITEMS
		;All items in control are about to be deleted	
		.elseif eax == LVN_DELETEITEM
		;An item is about to be deleted	
		.elseif eax == LVN_ENDLABELEDIT
		;Item in-place label editing has ended	
		.elseif eax == LVN_GETDISPINFO
		;Item information request	
		.elseif eax == LVN_GETINFOTIP
		;Tool tip information request	
		.elseif eax == LVN_HOTTRACK
		;User moved mouse over an item while in hot tracking mode	
		.elseif eax == LVN_INSERTITEM
		;A new item has been inserted	
		.elseif eax == LVN_ITEMACTIVATE
		;User activated an item	
		.elseif eax == LVN_ITEMCHANGED
		;An item has changed	
		.elseif eax == LVN_ITEMCHANGING
		;An item is changing	
		.elseif eax == LVN_KEYDOWN
		;A key has been pressed	
		.elseif eax == LVN_MARQUEEBEGIN
		;A bounding box selection has begun	
		.elseif eax == LVN_ODCACHEHINT
		;Virtual list view display area contents changed (cache information)	
		.elseif eax == LVN_ODFINDITEM
		;Virtual list view find callback item request	
		.elseif eax == LVN_ODSTATECHANGED
		;Virtual list view item state change notification	
		.elseif eax == LVN_SETDISPINFO
		;Item information must be updated					
		.elseif eax == NM_CLICK
		;User clicked left mouse button in control
		
			invoke MessageBox,NULL,SADR("clic"),SADR("Titre"),MB_OK
	
		.elseif eax == NM_CUSTOMDRAW
		;Custom draw request notification	
		.elseif eax == NM_DBLCLK
		;User double-clicked left mouse button in control	
		.elseif eax == NM_HOVER
		;Mouse is hovering over an item	
		.elseif eax == NM_KILLFOCUS
		;Control lost input focus	
		.elseif eax == NM_RCLICK
		;User clicked right mouse button in control	
		.elseif eax == NM_RDBLCLK
		;User double-clicked right mouse button in control	
		.elseif eax == NM_RELEASEDCAPTURE
		;Control is releasing mouse capture	
		.elseif eax == NM_RETURN
		;Control has the input focus and the user pressed ENTER	
		.elseif eax == NM_SETFOCUS
		;Control has received the input focus			
		.endif
 FindeNotify_Listview:
         mov eax,retour
         ret
Notify_Listview endp

;################################################################

CreerRemplirLigneListview PROC uses esi edi NumeroLigne:DWORD,pDataLigne:DWORD
			Local lvi:LV_ITEM
			Local CPTcol:DWORD
			Local ContenuColonne[100]:BYTE
			Local  retour:DWORD
			ZEROLOCALES retour
			
         mov retour,1
		mov eax,Listview.NbCol
		mov CPTcol,eax
		mov esi,pDataLigne
		mov lvi.iSubItem,0			;indice de colonne,toujours commencer premiere		
		PuPo lvi.iItem,NumeroLigne			;ligne (crer si elle n'existe pas)
		PuPo lvi.lParam,NumeroLigne			;numro ligne en paramtre
		mov lvi.imask,LVIF_TEXT+LVIF_PARAM				
		Newcolonne:
		;---------- remplir ligne NBLVligne, colonne iSubItem 0 (base 0=premire colonne)
		;charger donne, Listview_ligne db "un,deux,trois,quatre",0
		lea edi,ContenuColonne
		@@:
		.if byte ptr [esi] != "," && byte ptr [esi] != 0
			movsb
			jmp @B
		.endif
		mov byte ptr [edi],0
		.if byte ptr [esi] == ","
			inc esi		;point de dpart colonne suivante
		.endif
		
		lea eax,ContenuColonne				;le texte a mettre dans colonne
		mov lvi.pszText,eax
		.if lvi.iSubItem == 0
			;cre une nouvelle ligne
			invoke SendMessage,Listview.Handle,LVM_INSERTITEM,NULL,addr lvi
			;pour la suite,LVIF_PARAM invalide
			mov lvi.imask,LVIF_TEXT							
		.else
			;modifie l'lment prcdemment cr
			invoke SendMessage,Listview.Handle,LVM_SETITEM,NULL,addr lvi		
		.endif
		dec CPTcol
		jz  FindeRemplirLigneListview
		inc lvi.iSubItem
		jmp Newcolonne

 FindeRemplirLigneListview:
         mov eax,retour
         ret
CreerRemplirLigneListview endp

;################################################################






;------------------------------------------------------------------
; #########################################################################

;In,le handle mre ou NULL
;------ si handle == 0 ,on prend dimension XP de l'cran(-barre des taches)
;------ si handle != 0 ,on prend les dimensions internes de la feuille mre
;In/out adresse d'une structure DIM_CREATEWIN 
;------ a l'entre contient les dimensions en %
;------ a la sortie contient les dimensions en coordonnes cran
;----------------------------------------------------------------
;

;transforme les coordonnes d'une fentre pour cent ---> coordonnes cran
;################################################################
TransformePourCent PROC uses ebx hwnd:DWORD,dimcreatewin:DWORD 
			local Xecran:DWORD,Yecran,largemere,hautmere
			Local screen:RECT
			Local  retour:DWORD
			;pour centrer la fenetre 2 * posX + largeur = 100
			;				 2 * posY + hauteur = 100
			
         mov retour,0
	mov ebx,dimcreatewin
	
	.if hwnd == 0
		;---------------------------------------------------------------------------
		;conserve les proportions de la fenetre en fonction de la resolution d'ecran
		;----------------------------------------------------------------------------
		invoke GetSystemMetrics,SM_CXFULLSCREEN    ;max X cliente de l'ecran
		mov Xecran,eax
		mov edx,[DIM_CREATEWIN.posX][ebx]
		.if edx != 0
			invoke   PourCent,Xecran,edx			
			mov [DIM_CREATEWIN.posX][ebx],eax
		.endif
		mov edx,[DIM_CREATEWIN.largeur][ebx]
		.if edx != 0
			invoke   PourCent,Xecran,edx			
			mov [DIM_CREATEWIN.largeur][ebx],eax
		.endif		
		
		;pour XP la fonction tient compte de la barre des taches
		invoke  SystemParametersInfo,SPI_GETWORKAREA,NULL,addr screen,NULL
		mov Yecran,HAUTEUR(screen)
		mov edx,[DIM_CREATEWIN.posY][ebx]
		.if edx != 0
			invoke   PourCent,Yecran,edx			
			mov [DIM_CREATEWIN.posY][ebx],eax
		.endif	
		mov edx,[DIM_CREATEWIN.hauteur][ebx]
		.if edx != 0
			invoke   PourCent,Yecran,edx			
			mov [DIM_CREATEWIN.hauteur][ebx],eax
		.endif									

	.else
		;deux cas ou les informations sont diffrentes
		;la fille a la proprit child et posX,posY = 0
		;
		;invoke GetWindowLong,hwnd,GWL_STYLE
		;and eax,WS_CHILD		
		;----------
		;coordonnes en fonction de l'cran
		;les coordonnes sont donnes en fonction de la feuille mere	
		;transformer les % en dimension ecran
		invoke GetClientRect,hwnd,addr screen
		mov eax,LARGEUR (screen)
		mov largemere,eax
		mov eax,HAUTEUR (screen)
		mov hautmere,eax
		mov edx,[DIM_CREATEWIN.posX][ebx]
		.if edx != 0
			invoke PourCent,largemere,edx
			mov [DIM_CREATEWIN.posX][ebx],eax					
		.endif
		mov edx,[DIM_CREATEWIN.largeur][ebx]
		.if edx != 0
			invoke PourCent,largemere,edx
			mov [DIM_CREATEWIN.largeur][ebx],eax					
		.endif			
		;---------------------------------------
		mov edx,[DIM_CREATEWIN.posY][ebx]
		.if edx != 0
			invoke PourCent,hautmere,edx
			mov [DIM_CREATEWIN.posY][ebx],eax					
		.endif
		@@:
		mov edx,[DIM_CREATEWIN.hauteur][ebx]
		.if edx != 0
			invoke PourCent,hautmere,edx
			mov [DIM_CREATEWIN.hauteur][ebx],eax					
		.endif								
	.endif

 FindeTransformePourCent:
         mov eax,retour
         ret
TransformePourCent endp


; #########################################################################





comment 
 	uniquement pour exemple,demande a tre adapt au code

		;---------- remplir ligne NBLVligne, colonne iSubItem 0 (base 0=premire colonne)
		mov lvi.imask,LVIF_TEXT+LVIF_PARAM
		PuPo lvi.iItem,NBLVligne		;ligne (crer si elle n'existe pas)
		PuPo lvi.lParam,NBLVligne		;numro ligne en paramtre
		mov lvi.iSubItem,0			;indice de colonne,toujours commencer premiere
		PuPo lvi.pszText,adrCol1		;le texte a mettre dans colonne 
		invoke SendMessage,HmereListview,LVM_INSERTITEM,NULL,addr lvi

	;examiner une selection multiple
	;demande du nombre de slectionns
	;renvoi nombre + depart,c'est tout
	;il faut ensuite examin,toutes les lignes
	;depuis le point de dpart,pour arriver au nombre


				invoke SendMessage,HmereListview,LVM_GETSELECTEDCOUNT,NULL,NULL				
				mov lvcItemSelectedCount,eax
				;nombre de lignes
				;invoke debug,hwnd,lvcItemSelectedCount,SADR ("lvcItemSelectedCount")				
				.if eax == 0
					;mode d'emploi 406722
					invoke MessageBox,NULL,addr EmpoiLvi,SADR ("pas de slection"),MB_OK
					jmp findeNM_RCLICK
				.endif
				;renvoi le iSubItem du dbut de ligne
				invoke SendMessage,HmereListview,LVM_GETSELECTIONMARK,NULL,NULL
				xor edx,edx
				mov ecx,2
				.if eax != 0
					div ecx
				.endif
				mov lvcStartSelection,eax				
				;invoke debug,hwnd,lvcStartSelection,SADR ("lvcStartSelection")								
				;ne possde pas getselecteditems comme listbox
				;LVIS_SELECTED etat selectionn
				;rcuprer les infos sur la slection multiple
				
				mov lvi.imask,LVIF_PARAM
				PuPo lvi.iItem,lvcStartSelection
				mov lvi.iSubItem,0				
				invoke SendMessage,HmereListview,LVM_GETITEM,0,addr lvi
				selectionvalide:
				;dans tous les cas effacer de la liste visuelle
				;invoke debug,hwnd,lvcStartSelection,SADR ("effacer")				
				invoke SendMessage,HmereListview,LVM_DELETEITEM,lvcStartSelection,0
				mov eax,lvi.lParam	;debug
				invoke EffacerCeMessage,lvi.lParam
				dec lvcItemSelectedCount
				.if lvcItemSelectedCount == 0
					jmp findeNM_RCLICK
				.endif
				EtatDusuivant:
				;rechercher les suivants
				mov lvi.imask,LVIF_PARAM + LVIF_STATE
				PuPo lvi.iItem,lvcStartSelection
				mov lvi.iSubItem,0				
				mov lvi.stateMask,LVIS_SELECTED				
				invoke SendMessage,HmereListview,LVM_GETITEM,0,addr lvi
				.if eax == TRUE
					.if lvi.state == 0 ;pas selectionner
						inc lvcStartSelection
						;invoke debug,hwnd,lvcStartSelection,SADR ("lvcStartSelection")
						jmp EtatDusuivant
					.else
						jmp selectionvalide
					.endif
				.endif

